<?php
///////////////////////////////////////////////////////////////////////////////
//                                                                           //
// Copyright (C) 2009  Phorum Development Team                               //
// http://www.phorum.org                                                     //
//                                                                           //
// This program is free software. You can redistribute it and/or modify      //
// it under the terms of either the current Phorum License (viewable at      //
// phorum.org) or the Phorum License that was distributed with this file     //
//                                                                           //
// This program is distributed in the hope that it will be useful,           //
// but WITHOUT ANY WARRANTY, without even the implied warranty of            //
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                      //
//                                                                           //
// You should have received a copy of the Phorum License                     //
// along with this program.                                                  //
//                                                                           //
///////////////////////////////////////////////////////////////////////////////

if (!defined("PHORUM_ADMIN")) return;

// Available doctypes as supported by HTML Purifier
$doctypes = array(
    'HTML 4.01 Strict'         => 'HTML 4.01 Strict',
    'HTML 4.01 Transitional'   => 'HTML 4.01 Transitional',
    'XHTML 1.0 Strict'         => 'HTML 1.0 Strict',
    'XHTML 1.0 Transitional'   => 'XHTML 1.0 Transitional (Phorum\'s default)',
    'XHTML 1.1'                => 'XHTML 1.1'
);

// Phorum groups
$groups = phorum_db_get_groups(0, TRUE);

// Initialize the doctype configuration.
if (!is_array($PHORUM['mod_html'])) $PHORUM['mod_html'] = array();
if (!isset($PHORUM['mod_html']['doctype'])) {
    // Phorum's template default
    $PHORUM['mod_html']['doctype'] = 'XHTML 1.0 Transitional';
}

// Initialize the rules configuration.
if (!isset($PHORUM['mod_html']['groups_enabled'])) {
    $PHORUM['mod_html']['groups_enabled'] = "0";
}
if (!isset($PHORUM['mod_html']['anyone_enabled'])) {
    $PHORUM['mod_html']['anyone_enabled'] = "0";
}
if (!isset($PHORUM['mod_html']['users_enabled'])) {
    $PHORUM['mod_html']['users_enabled'] = "0";
}
if (!isset($PHORUM['mod_html']['users_min_post_count'])) {
    $PHORUM['mod_html']['users_min_post_count'] = "";
}
if (!isset($PHORUM['mod_html']['users_min_registration_age'])) {
    $PHORUM['mod_html']['users_min_registration_age'] = "";
}
if (!isset($PHORUM['mod_html']['user_is_moderator'])) {
    $PHORUM['mod_html']['user_is_moderator'] = "0";
}

define('HTML_FORM_SPACER','&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;');

// Save settings.
if (count($_POST))
{
    if (isset($_POST['doctype']) && isset($doctypes[$_POST['doctype']])) {
        $PHORUM['mod_html']['doctype'] = $_POST['doctype'];
    }

    // Did we change to anyone enabled?
    if (isset($_POST['html_anyone_enabled'])) {
        $PHORUM['mod_html']['anyone_enabled'] = $_POST['html_anyone_enabled'];
        // If anyone enabled, disable groups and users
        if ($PHORUM['mod_html']['anyone_enabled']) {
            $PHORUM['mod_html']['groups_enabled'] = "0";
            $PHORUM['mod_html']['users_enabled'] = "0";
        }
    }
    else {

        // Did we change to groups enabled?
        if (isset($_POST['html_groups_enabled'])) {
            $PHORUM['mod_html']['groups_enabled'] = $_POST['html_groups_enabled'];
            // If groups enabled, disable anyone
            if ($PHORUM['mod_html']['groups_enabled']) $PHORUM['mod_html']['anyone_enabled'] = "0";
        }
        else
            $PHORUM['mod_html']['groups_enabled'] = "0";
    
        // Did we change to users enabled?
        if (isset($_POST['html_users_enabled'])) {
            $PHORUM['mod_html']['users_enabled'] = $_POST['html_users_enabled'];
            // If users enabled, disable anyone
            if ($PHORUM['mod_html']['users_enabled']) $PHORUM['mod_html']['anyone_enabled'] = "0";
        }
        else
            $PHORUM['mod_html']['users_enabled'] = "0";

        // Was a new group selected?
        if (isset($_POST['html_group_new']) && $_POST['html_group_new']) {
            $active_forum_chk = (isset($_POST['html_group_new_active_forum'])) ? $_POST['html_group_new_active_forum'] : "0";
            $PHORUM['mod_html']['groups'][$_POST['html_group_new']] =
                                              array(
                                                     "group_id" => $_POST['html_group_new'],
                                                     "active_forum" => $active_forum_chk
                                                    );
            $PHORUM['mod_html']['groups_enabled'] = "1";
            $PHORUM['mod_html']['anyone_enabled'] = "0";
        }

        // Loop through the groups and handle any edits or deletion
        foreach($groups as $group) {
            $group_id = $group['group_id'];
            if (isset($_POST['html_group_new']) && $group_id == $_POST['html_group_new'])
                continue;

            // delete or edit?
            if (isset($_POST["html_group_$group_id"."_delete"])) {
                unset($PHORUM['mod_html']['groups'][$group_id]);
                if (count($PHORUM['mod_html']['groups']) == 0)
                    $PHORUM['mod_html']['groups_enabled'] = "0";
            }
            else {
                if (isset($PHORUM['mod_html']['groups'][$group_id])) {
                    $active_forum_chk = (isset($_POST['html_group_'.$group_id.'_active_forum'])) ? $_POST['html_group_'.$group_id.'_active_forum'] : "0";
                    $PHORUM['mod_html']['groups'][$group_id]['active_forum'] = $active_forum_chk;
                }
            }
        }

        if (isset($_POST['html_users_enabled']))
        {
            // A user min post count?
            $PHORUM['mod_html']['users_min_post_count'] = (is_numeric($_POST['html_user_min_post_count'])) ? intval($_POST['html_user_min_post_count']) : "";
            // A user min registration age?
            $PHORUM['mod_html']['users_min_registration_age'] = (is_numeric($_POST['html_user_min_registration_age'])) ? $_POST['html_user_min_registration_age'] : "";
            // A user must be a moderator?
            $PHORUM['mod_html']['user_is_moderator'] = (isset($_POST['html_user_is_moderator'])) ? $_POST['html_user_is_moderator'] : "0";

            // If User Tagging module is present, we can also add user tags as criteria for entering HTML
            if (isset($PHORUM['mod_user_tagging']) && !empty($PHORUM['mod_user_tagging']['rules'])) {
                foreach ($PHORUM['mod_user_tagging']['rules'] as $rule)
                {
                    $rule_id = $rule['id'];
                    if (isset($_POST["html_user_tagging_rule_$rule_id"]) ? $_POST["html_user_tagging_rule_$rule_id"] : "0")
                        $PHORUM['mod_html']['user_tagging_rules'][$rule_id] = "1";
                    elseif (isset($PHORUM['mod_html']['user_tagging_rules'][$rule_id])) {
                        unset($PHORUM['mod_html']['user_tagging_rules'][$rule_id]);
                        if (count($PHORUM['mod_html']['user_tagging_rules']) == 0)
                            unset($PHORUM['mod_html']['user_tagging_rules']);
                    }
                }
            }
        }
    }

    phorum_db_update_settings(array('mod_html' => $PHORUM['mod_html']));
    phorum_admin_okmsg("The settings were successfully saved.");
}

require_once('./include/admin/PhorumInputForm.php');
$frm = new PhorumInputForm ("", "post", "Save settings");
$frm->hidden("module", "modsettings");
$frm->hidden("mod", "html");

$frm->addbreak("Configuration for the HTML in Messages module");

$frm->addmessage(
    "<p>
       To be able to correctly clean up HTML code in a message,
       this module needs to know what kind of HTML code (the \"doctype\")
       to expect. If you are unsure what doctype you are using,
       then take a look at your header.tpl template file. At the start
       of that file, you will find a line looking somewhat like this:
     </p>
     <p>
       &lt;!DOCTYPE html PUBLIC \"-//W3C//DTD <b style=\"color:green\">XHTML 1.0 Transitional</b>//EN\"
       \"http://www.w3.org/TR/xhtml1/DTD/<b style=\"color:green\">xhtml1-transitional</b>.dtd\"&gt;
     </p>
     <p>
       In this example, you can see that the HTML doctype to use would be
       \"XHTML 1.0 Transitional\". This is in fact the default doctype that
       Phorum uses for its bundled templates. So if you are using
       (a modified version of) one of Phorum's bundled templates,
       then you can select this doctype.
     </p>"
);

$frm->addrow(
    'What document type do you use for your template?',
    $frm->select_tag('doctype', $doctypes, $PHORUM['mod_html']['doctype'])
);

$frm->addmessage("<p />");

$frm->addbreak("Control who can enter HTML in forum messages");
$frm->addrow(
    $frm->checkbox("html_administrators_enabled", "1", "", "1", "DISABLED")."Adminstrators",
    "(always enabled)"
);

$frm->addsubbreak();

$frm->addrow(
    $frm->checkbox("html_anyone_enabled", "1", "Anyone", $PHORUM['mod_html']['anyone_enabled'], "onclick='anyone_onclick(this.form);'"),
    "(not recommended)"
);
$frm->addsubbreak();

$frm->addrow(
    $frm->checkbox("html_users_enabled", "1", "Logged in users", $PHORUM['mod_html']['users_enabled'], "onclick='permission_onclick(this.form);'")
);

$frm->addrow(HTML_FORM_SPACER."who are moderators", $frm->checkbox("html_user_is_moderator", "1", "(if checked, user must be a moderator in the active forum)", $PHORUM['mod_html']['user_is_moderator']));
$frm->addrow(HTML_FORM_SPACER."who have a post count equal to or more than (>=)", $frm->text_box("html_user_min_post_count", $PHORUM['mod_html']['users_min_post_count'], 7)." posts (enter any integer or leave blank to disable)");
$frm->addrow(HTML_FORM_SPACER."whose registration dates are equal to or more than (>=)", $frm->text_box("html_user_min_registration_age", $PHORUM['mod_html']['users_min_registration_age'], 7)." days ago (enter any integer or leave blank to disable)");


// If User Tagging module is present, we can also add a user tags as criteria for entering HTML
if (isset($PHORUM['mod_user_tagging']) && $PHORUM["mods"]["user_tagging"] && !empty($PHORUM['mod_user_tagging']['rules'])) {
    $user_tagging_checks = "";
    foreach ($PHORUM['mod_user_tagging']['rules'] as $rule)
    {
        $rule_id = $rule['id'];
        $checked = isset($PHORUM['mod_html']['user_tagging_rules'][$rule_id]) ? $PHORUM['mod_html']['user_tagging_rules'][$rule_id] : "0";
        $rule_link = "<a href='".phorum_admin_build_url(array("module=modsettings", "mod=user_tagging", "edit_rule=1", "id=".$rule_id))."'>View</a>";

        $user_tagging_checks .= $frm->checkbox("html_user_tagging_rule_$rule_id", "1", $rule['name'], $checked) . " ".$rule_link."<br />";
    }
    $frm->addrow(HTML_FORM_SPACER."who are tagged by the following User Tagging Module rules:", $user_tagging_checks);
}
$frm->addsubbreak();

if (count($groups) > 0) {
    $frm->addrow(
        $frm->checkbox("html_groups_enabled", "1", "Approved members of the following groups", $PHORUM['mod_html']['groups_enabled'], "onclick='permission_onclick(this.form);'")
    );
    
    $grouplist[0] = "Add a group...";
    foreach ($groups as $group) {
        if (isset($PHORUM['mod_html']['groups'][$group['group_id']])) continue;
        $grouplist[$group['group_id']] = $group['name'];
    }
    
    if (count($grouplist) > 1)
        $frm->addrow(
            "<center>" . $frm->select_tag('html_group_new', $grouplist, "", "onchange='this.form.submit();'") . "</center>",
            $frm->checkbox("html_group_new_active_forum", "1", "", "") . "group must be attached to active forum"
        );
    
    if (is_array($PHORUM['mod_html']['groups'])) {
        foreach($PHORUM['mod_html']['groups'] as $group) {
            $group_id = $group["group_id"];
            $group_info = phorum_db_get_groups($group_id);
            if (count($group_info) == 0)
                continue;
    
            $frm->addrow(
                "<nobr>".HTML_FORM_SPACER."<input type='submit' name='html_group_$group_id"."_delete' value='remove'>&nbsp;".$group_info[$group_id]["name"],
                $frm->checkbox("html_group_$group_id"."_active_forum", "1", "group must be attached to active forum", $group["active_forum"])
            );
        }
    }
    
    $frm->addsubbreak();
}
else
    $frm->hidden("html_groups_enabled","0");

$frm->show();
?>
<script language="javascript">
function anyone_onclick(form) {
    if (form.html_anyone_enabled.checked) {
        form.html_groups_enabled.checked = false;
        form.html_users_enabled.checked = false;
    }
    toggle_permissions(form);
}

function permission_onclick(form) {
    if (form.html_anyone_enabled.checked && (form.html_groups_enabled.checked || form.html_users_enabled.checked))
        form.html_anyone_enabled.checked = false;
    toggle_permissions(form);
}

function toggle_permissions(form) {
    for(i=0; i<form.elements.length; i++) {
        var element = form.elements[i];
        if (element.name.substring(0,11) == "html_group_") {
            element.disabled = !form.html_groups_enabled.checked;
        }
        if (element.name.substring(0,10) == "html_user_") {
            element.disabled = !form.html_users_enabled.checked;
        }
    }
}

form = document.forms[1];
toggle_permissions(form);

</script>